<?php
/*
 * $Revision: 1.3 $
 *
 * $RCSfile: MapMarkersAdmin.inc
 *
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2005 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
/**
 * @version 0.5.0
 * @package Map
 * @author Steven N. Severinghaus <sns@severinghaus.org>
 *
 * This is some of the ugliest code I've ever written. Please do not
 * judge me by it. :)
 */

GalleryCoreApi::requireOnce('modules/map/classes/mapHelper.class');
GalleryCoreApi::requireOnce('modules/map/classes/GoogleMapUtilities.class');

/**
 * @package map
 * @subpackage UserInterface
 */
class MapMarkersAdminController extends GalleryController {

    /**
     * @see GalleryController::handleRequest
     */
    function handleRequest($form) {

        include(dirname(__FILE__).'/includes/MapAdminControllerInit.inc');

        //If we want to "add" a marker, call the marker creation tool
        if (isset($form['action']['add'])) {

        $results['status'] = '';
        $results['error'] = '';
        $results['redirect']['view'] = 'core.SiteAdmin';
        $results['redirect']['subView'] = 'map.MapMarkersAdmin';
        $results['redirect']['mode'] = 'Tool';
        }

        //Save the Markers settings
        if (isset($form['action']['save'])) {
            // Check for errors
            if (!array_key_exists('useMarkerSet', $form) || !array_key_exists('useAlbumMarkerSet', $form))
            {
                $error[] = 'form[error][nomarkers]';
//            } elseif (!is_numeric($form['regroupDist']) || intval($form['regroupDist'])!=$form['regroupDist'] || $form['regroupDist'] <= 0)
//            {
//                $error[] = 'form[error][regroupDist]';
//            } elseif (!array_key_exists('regroupIcon', $_POST) and array_key_exists('regroupItems',$form) and $form['regroupItems'])
//            {
//                $error[] = 'form[error][marker]';
            } else
            {
                if(!array_key_exists('regroupDist', $form))          $form['regroupDist']='15';

                //make sure the 'Colors' CustomField is inline with the marker set selected
                if (isset($form['useMarkerSet']))
                {
                    $handle = fopen ($basegallerydir.'map/images/markers/'.$form['useMarkerSet'].'/colorlist','r');
                    $list = explode("*", fread($handle,filesize($basegallerydir.'map/images/markers/'.$form['useMarkerSet'].'/colorlist')-1));
                    fclose($handle);

                    list ($ret, $param) = mapHelper::loadParameters(0, false);

                    $newparam['common'] = array();
                    foreach ($param['common'] as $pos => $a)
                    {
                        if ($param['common'][$pos]['field'] == "Colors")
                        {
                            $newparam['common'][] =
                                array('field' => $param['common'][$pos]['field'],
                                    'summary' => $param['common'][$pos]['summary'],
                                    'detail' => $param['common'][$pos]['detail'],
                                    'choices' => $list);
                        }
                        else
                        {
                            $newparam['common'][] =
                                array('field' => $param['common'][$pos]['field'],
                                    'summary' => $param['common'][$pos]['summary'],
                                    'detail' => $param['common'][$pos]['detail'],
                                    'choices' => $param['common'][$pos]['choices']);
                        }
                    }
                    $ret = mapHelper::saveParameters($newparam, 0);

                }

                if (!isset($form['defaultphotocolor'])) $form['defaultphotocolor']='';
                if (!isset($form['defaultalbumcolor'])) $form['defaultalbumcolor']='';
                if (!isset($form['defaultgroupcolor'])) $form['defaultgroupcolor']='';
//                if (!isset($_POST['regroupIcon'])) $form['regroupIcon']="";
//                else $form['regroupIcon'] = $_POST['regroupIcon'];

                // Save parameters if there have been no errors
                foreach (array('useMarkerSet','useAlbumMarkerSet','useGroupMarkerSet','defaultphotocolor','defaultgroupcolor','defaultalbumcolor') as $setting) { //, 'regroupDist', 'regroupIcon'
                    GalleryCoreApi::setPluginParameter('module', 'map', $setting, $form[$setting]);
                }

                foreach (array('useParentColor') as $setting) { //, 'regroupAlbums','regroupItems'
                    GalleryCoreApi::setPluginParameter('module', 'map', $setting,
                        (isset($form[$setting]) && $form[$setting]) ? 1 : 0);
                }

            $status['saved'] = 1;

            }

            // Figure out the method we will use
            $method = empty($error) ? 'redirect' : 'delegate';
            $results['status'] = $status;
            $results['error'] = $error;
            $results[$method]['view'] = 'core.SiteAdmin';
            $results[$method]['subView'] = 'map.MapMarkersAdmin';

        }

        //Generate the markers according to specs
        if (isset($form['action']['generate'])) {
            // Check for errors

            if(!array_key_exists('base', $form)) $error[] = 'form[error][base]';
            elseif ($form['setname'] == "") $error[] = 'form[error][setname]';
            elseif ($form['setname'] == "multi") $error[] = 'form[error][multiname]';
            else  // No errors detected
              {
                $basemarkername = $form['base'];
                $setname = $form['setname'];

                 //create the marker dir
                if (!is_dir($basegallerydir.'map/images/markers/'.$setname))
                 {
                   if (!mkdir($basegallerydir."map/images/markers/".$setname))
                   {
                     $error[] = 'form[error][createdir]';
                   }
                 }
                 $resize = "";
                 $basepngdir = $base.'modules/map/images/basemarkers/';

                 // Figure out if a resize is needed and create the appropriate command
                 if ($form['size'][0] != "same")
                 {
                   if ($form['size'][0] == "custom")
                   {
                     $resize = ' -resize '.$form["ImageHeight"].'x'.$form["ImageWidth"];
                   }
                   else
                   {
                     $currentsize = getimagesize($basegallerydir."map/images/basemarkers/".$basemarkername.".png");
                     $height50 = $currentsize[1] / 2;
                     $width50 = $currentsize[0] / 2;
                     $height200 = $currentsize[1] * 2;
                     $width200 = $currentsize[0] * 2;
                     if ($form['size'][0] == "50") {$resize = ' -resize '.$width50.'x'.$height50;}
                     if ($form['size'][0] == "200") {$resize = ' -resize '.$width200.'x'.$height200;}
                   }
                 }

                 //Check for the colors selected and input them to an array
                 $colors = array ('ORANGE' => '-modulate 95,127,127','PURPLE' => '-modulate 95,127,255','YELLOW' => '-modulate 105,100,140','GREEN' => '-modulate 95,127,159','BLUE' => '-modulate 95,95,31','RED' => '-modulate 95,255,95','AQUA' => '-modulate 95,120,201','WHITE' => '-modulate 95,0,0','GRAY' => '-modulate 47,0,0','BLACK' => '-modulate 0,0,0');

                 if ($form['colors'] <> "all")
                 {
                   $colors = array();
                   if (isset($_POST['blue'])) {$colors = $colors + array ('BLUE' => '-modulate 95,95,31',);}
                   if (isset($_POST['red'])) {$colors = $colors + array ('RED' => '-modulate 95,255,95',);}
                   if (isset($_POST['yellow'])) {$colors = $colors + array ('YELLOW' => '-modulate 95,100,140',);}
                   if (isset($_POST['green'])) {$colors = $colors + array ('GREEN' => '-modulate 95,127,159',);}
                   if (isset($_POST['orange'])) {$colors = $colors + array ('ORANGE' => '-modulate 95,127,127',);}
                   if (isset($_POST['aqua'])) {$colors = $colors + array ('AQUA' => '-modulate 95,255,191',);}
                   if (isset($_POST['purple'])) {$colors = $colors + array ('PURPLE' => '-modulate 95,127,255',);}
                   if (isset($_POST['white'])) {$colors = $colors + array ('WHITE' => '-modulate 95,0,0',);}
                   if (isset($_POST['black'])) {$colors = $colors + array ('BLACK' => '-modulate 0,0,0',);}
                   if (isset($_POST['grey'])) {$colors = $colors + array ('GRAY' => '-modulate 47,0,0',);}
                 }

                 //Put the colorlist in a file for later retrieval
                 $colorlist = array();
                 $handle = fopen ($basegallerydir.'map/images/markers/'.$setname.'/colorlist','w');
                 foreach ($colors as $name => $value)
                 {
                   $colorlist[] = $name;
                   fwrite ($handle,$name."*");
                 }
                 fclose ($handle);

                 list ($ret, $added) = mapHelper::addField ("Colors","common",0);
         	 list ($ret, $param) = mapHelper::loadParameters(0, false);

                 //Setup the "Colors" CustomEditField with the new list of color
                 $newparam['common'] = array();
         	 $itemid = 0;
         	 foreach ($param['common'] as $pos => $a)
                  {
                    if ($param['common'][$pos]['field'] == "Colors")
                    {
                      $newparam['common'][] =
				array('field' => $param['common'][$pos]['field'],
				      'summary' => $param['common'][$pos]['summary'],
				      'detail' => $param['common'][$pos]['detail'],
				      'choices' => $colorlist);
                    }
                    else
                    {
                      $newparam['common'][] =
				array('field' => $param['common'][$pos]['field'],
				      'summary' => $param['common'][$pos]['summary'],
				      'detail' => $param['common'][$pos]['detail'],
				      'choices' => $param['common'][$pos]['choices']);
                    }
                  }
          	   $ret = mapHelper::saveParameters($newparam, 0);

                 $statusexec = 0;

	        foreach (array('path', 'jpegQuality', 'cmykSupport') as $key) 
                {
		  list ($ret, $magic[$key]) = GalleryCoreApi::getPluginParameter('module', 'imagemagick', $key);
                  if ($ret) {
                       return $ret->wrap(__FILE__, __LINE__);
                  }
                }
                $oldcwd = getcwd();
                chdir($magic['path']);

                 //For each color, creates a marker using Convert form the imagemagick toolkit
                 foreach ($colors as $color => $modul)
                 {
                   $command = 'convert '.$modul.$resize.' "'.$basegallerydir.'map/images/basemarkers/'.$basemarkername.'.png" "'.$basegallerydir.'map/images/markers/'.$setname.'/marker_'.$color.'.png"';
                   $returnstuff = system($command);
                   //if the marker created does not exist, then something went wrong, break out and display an error message
                   if (!file_exists($basegallerydir.'map/images/markers/'.$setname.'/marker_'.$color.'.png'))
                   {
                     $statusexec = 1;
                     $error[] = 'form[createicons]';
                     break;
                   }
                 }
                 chdir($oldcwd);
                 if (empty($error)) {$status['generated']=1;}
               }

            // Redirect to the AdminPanel once done :D
            $method = empty($error) ? 'redirect' : 'delegate';
            $results['status'] = $status;
            $results['error'] = $error;
            $results[$method]['view'] = 'core.SiteAdmin';
            $results[$method]['subView'] = 'map.MapMarkersAdmin';
            $results[$method]['mode'] = empty($error) ? '' : 'Tool';;

        }

        //Deleting a markerSet
        if (isset($form['action']['delete'])) {

            $status['deleted']=0;

            $dir = $basegallerydir.'map/images/markers/'.$form['deleteMarkerSet'];

            //Delete all file in the folder and then delete the folder
            GalleryCoreApi::requireOnce('modules/map/classes/filecopy.class');
            $mydir = dir($dir);
            while (($obj = $mydir->read()) !== false) {
                if ($obj!='.' && $obj!='..') {
                    $lobj = $dir . "/" . $obj;
                    is_dir($lobj)? rm($lobj) : unlink($lobj);
                }
            }
            $mydir->close();
            rmdir($dir);

            $status['deleted']=1;

            // return status and display the Legend Admin Panel again
            $method = empty($error) ? 'redirect' : 'delegate';
            $results['status'] = $status;
            $results['error'] = $error;
            $results[$method]['view'] = 'core.SiteAdmin';
            $results[$method]['subView'] = 'map.MapMarkersAdmin';

        }

        //Upload a new basemarker and then return to the tool page
        if (isset($form['action']['upload'])) {
            //checking for error
            if ($form['name'][1] == "") {
              $error[] = 'form[error][nofileselected]';
            } elseif ($form['type'][1] <> "image/png" and $form['type'][1] <> "image/x-png") {
              $error[] = 'form[error][badfileselected]';
            } elseif ($form['tmp_name'][1] == "") {
              $error[] = 'form[error][notuploaded]';
            } elseif (!move_uploaded_file($form['tmp_name'][1], $basegallerydir."map/images/basemarkers/".$form['name'][1])) {
              $error[] = 'form[error][rightserror]';
            } else {
              $status['uploaded'] = 1;
            }
            $method = empty($error) ? 'redirect' : 'delegate';
            $results['status'] = $status;
            $results['error'] = $error;
            $results[$method]['view'] = 'core.SiteAdmin';
            $results[$method]['subView'] = 'map.MapMarkersAdmin';
            $results[$method]['mode'] = 'Tool';

        }

        //Cancel hit, return to the default adminpage
        if (isset($form['action']['cancel'])) {
            $results['status'] = $status;
            $results['error'] = array ();
            $results['redirect']['view'] = 'core.SiteAdmin';
            $results['redirect']['subView'] = 'map.MapMarkersAdmin';

        }

        if (isset($form['action']['viewall'])) {
            $results['status'] = $status;
            $results['error'] = array ();
            $results['redirect']['view'] = 'core.SiteAdmin';
            $results['redirect']['subView'] = 'map.MapMarkersAdmin';
            $results['redirect']['mode'] = 'ViewMarkers';

        }

        //Upload a new icon and then return to the regroup page
        if (isset($form['action']['uploadicon'])) {
            //checking for error
            if ($form['name'][2] == "") {
              $error[] = 'form[error][nofileselected]';
            } elseif ($form['type'][2] <> "image/png" and $form['type'][2] <> "image/x-png") {
              $error[] = 'form[error][badfileselected]';
            } elseif ($form['tmp_name'][2] == "") {
              $error[] = 'form[error][notuploaded]';
            } elseif (!move_uploaded_file($form['tmp_name'][2], $basegallerydir."map/images/multi/".$form['name'][2])) {
              $error[] = 'form[error][rightserror]';
            } else {
              $status['uploaded'] = 1;
            }
            $method = empty($error) ? 'redirect' : 'delegate';
            $results['status'] = $status;
            $results['error'] = $error;
            $results[$method]['view'] = 'core.SiteAdmin';
            $results[$method]['subView'] = 'map.MapMarkersAdmin';

        }

        return array (null, $results);
    }
}

/**
 * @package map
 * @subpackage UserInterface
 */
class MapMarkersAdminView extends GalleryView {
    /**
     * @see GalleryView::loadTemplate
     */
    function loadTemplate(&$template, &$form) {

        include(dirname(__FILE__).'/includes/MapAdminViewInit.inc');
        $form['formName'] = 'MapMarkersAdmin';
        $template->head('modules/map/includes/GoogleMap.css');
        $template->javascript('modules/map/GoogleMap.js');

        $basepngdir = $basegallerydir.'modules/map/images/basemarkers/';
        $pngdir = $base.'modules/map/images/basemarkers/';

        //verify that the module install was done right, maybe some missing files ?
        if (!is_dir($basepngdir)) $form['nobase'] = 'brokendir';
        else $form['basemarkers'] = GoogleMapUtilities::TableFromFiles($basegallerydir,$base,'modules/map/images/basemarkers/');

        $form['multimarkers'] = GoogleMapUtilities::TableFromFiles($basegallerydir,$base,'modules/map/images/multi/');

        $mydir = dir($basegallerydir.'modules/map/images/markers/');
        while (($file = $mydir->read()) !== false)
        {
          if ((is_dir($basegallerydir.'modules/map/images/markers/'.$file)) and (substr($file,-1) <> ".") and ($file != "CVS")) $form['markers'][] = $file;
        }
        if (array_key_exists('markers',$form)) $form['markerlist'] = "\"".implode("\",\"", $form['markers'])."\"";


        // Set default values for undefined plugin parameters
        if(!array_key_exists('regroupAlbums', $form))        $form['regroupAlbums']=false;
        if(!array_key_exists('regroupItems', $form))         $form['regroupItems']=false;
        if(!array_key_exists('regroupDist', $form))          $form['regroupDist']=15;
        if(!array_key_exists('regroupIcon', $form))          $form['regroupIcon']="zoom-in-trans";
        if(!array_key_exists('multirows', $form))            $form['multirows']=array();
        if(!array_key_exists('useMarkerSet', $form))         $form['useMarkerSet']="smallpushpins";
        if(!array_key_exists('useAlbumMarkerSet', $form))    $form['useAlbumMarkerSet']="smallpushpins";
        if(!array_key_exists('useGroupMarkerSet', $form))    $form['useGroupMarkerSet']="smallpushpins";
        if(!array_key_exists('defaultalbumcolor', $form))    $form['defaultalbumcolor']="YELLOW";
        if(!array_key_exists('defaultgroupcolor', $form))    $form['defaultgroupcolor']="RED";
        if(!array_key_exists('defaultphotocolor', $form))    $form['defaultphotocolor']="GREEN";
        if(!array_key_exists('useParentColor', $form))       $form['useParentColor']=false;
        if(!array_key_exists('Colorlists', $form))           $form['Colorlists']=array();
        if(!array_key_exists('colorAoption', $form))         $form['colorAoption']="";
        if(!array_key_exists('colorPoption', $form))         $form['colorPoption']="";
        if(!array_key_exists('colorGoption', $form))         $form['colorGoption']="";

        //Create the list of marker available and select the right one for Photos & albums
        $form['markerset'] = GoogleMapUtilities::OptionFromFolder($basegallerydir.'modules/map/images/markers/',$form['useMarkerSet']);
        $form['albummarkerset'] = GoogleMapUtilities::OptionFromFolder($basegallerydir.'modules/map/images/markers/',$form['useAlbumMarkerSet']);
        $form['groupmarkerset'] = GoogleMapUtilities::OptionFromFolder($basegallerydir.'modules/map/images/markers/',$form['useGroupMarkerSet']);

        //Create the list of available color for the selected markerset for Photos, albums and Groups
        $form['colorPoption'] = GoogleMapUtilities::OptionFromColorList($basegallerydir.'modules/map/images/markers/'.$form['useMarkerSet'],$form['defaultphotocolor']);
        $form['colorGoption'] = GoogleMapUtilities::OptionFromColorList($basegallerydir.'modules/map/images/markers/'.$form['useGroupMarkerSet'],$form['defaultgroupcolor']);
        $form['colorAoption'] = GoogleMapUtilities::OptionFromColorList($basegallerydir.'modules/map/images/markers/'.$form['useAlbumMarkerSet'],$form['defaultalbumcolor']);

        include(dirname(__FILE__).'/includes/MapAdminEdits.inc');

        $form['allmarkers'] = GoogleMapUtilities::AllMarkers();

  	if ($template->hasVariable('SiteAdmin')) {
  	    $SiteAdmin =& $template->getVariableByReference('SiteAdmin');
  	    $SiteAdmin['enctype'] = 'multipart/form-data';
  	} else {
  	    $SiteAdmin['enctype'] = 'multipart/form-data';
  	    $template->setVariable('SiteAdmin', $SiteAdmin);
  	}

          $template->setVariable('controller', 'map.MapMarkersAdmin');
  	return array(null,
  		     array('body' => 'modules/map/templates/MapMarkersAdmin.tpl'));
      }
}

?>